' search_msmq.vbs v0.1
' Authored by Chris Li of Ringus
' This is a NSClient++ addon script for Nagios that will search for specific string in a given queue.
' If the string is found it returns CRITICAL, otherwise it returns OK

Option Explicit
Const MQ_RECEIVE_ACCESS = 1 
Const MQ_SEND_ACCESS = 2 
Const MQ_DENY_NONE = 0 
Const MQ_PEEK_ACCESS = 32

if WScript.Arguments.Count <> 2 then
	call help()
	wscript.quit(2)
end if


Dim SearchStr 
SearchStr = WScript.Arguments(1)
Dim FormatName
FormatName = "DIRECT=OS:localhost\private$\" & WScript.Arguments(0)
Dim MSMQQueueInfo 
Set MSMQQueueInfo = CreateObject("MSMQ.MSMQQueueInfo")
MSMQQueueInfo.FormatName = FormatName
Dim MSMQQueue
Set MSMQQueue = CreateObject("MSMQ.MSMQQueue")
Dim MSMQMessage
Set MSMQMessage = CreateObject("MSMQ.MSMQMessage")


Set MSMQQueue = MSMQQueueInfo.Open(MQ_RECEIVE_ACCESS, MQ_DENY_NONE)
Dim message
If getMSMQCount(FormatName)>0 then
	Set message = MSMQQueue.PeekCurrent()
	if instr(message.body, SearchStr)>0 then 
		wscript.echo "CRITICAL - String (" & SearchStr & ") found in MSMQ"
		wscript.quit(2)
	end if
	Do While (Not message Is Nothing) and (getMSMQCount(FormatName)>0)
		if instr(message.body, SearchStr)>0 then 
			wscript.echo "CRITICAL - String (" & SearchStr & ") found in MSMQ"
			wscript.quit(2)
		end if
		Set message = MSMQQueue.PeekNext(False, true, 0)
	Loop
	wscript.echo "OK - String (" & SearchStr & ") NOT found in MSMQ"
	wscript.quit(0)
end If

function getMSMQCount(qformat)
	dim MSMQApp, Mgmt
	Set MSMQApp = CreateObject("MSMQ.MSMQApplication")
	Set Mgmt = CreateObject("MSMQ.MSMQManagement")
	Mgmt.Init ,,qFormat
	getMSMQCount = CLng(Mgmt.MessageCount)
end function

Function Help()
  Wscript.Echo "Usage:"
  Wscript.Echo "search_msmq.vbs [queuename] [search string]"
End Function